
function printformrow($type,$name,$value,$descr,$size) {
	print("<tr><td align=\"right\">$descr: </td><td><input type=\"$type\" name=\"$name\" value=\"$value\" size=\"$size\"></td></tr>\n");
}

function printerrors() {
	global $errors;
	if (count($errors)>0) {
		print('<div class="errors">Some errors occurred:<ul>');
		while (($error=array_shift($errors))!=NULL) {
			print('<li>'.$error.'</li>');
		}
		print('</ul></div>');
	}
}

function printform() {
	global $user,$pw1,$pw2,$oldpw;
	print('<form method="POST"><table><tr><th colspan="2">Inserimento dati utente</th></tr>');
	printformrow('text','user',$user,'Nome utente',40);
	printformrow('password','oldpw',$oldpw,'Vecchia password',40);
	printformrow('password','pw1',$pw1,'Nuova password',40);
	printformrow('password','pw2',$pw2,'Ripeti password',40);
	printformrow('submit','cmd','Cambia password','Premi il pulsante per confermare cambio password',0);
	print('</table></form>');
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN
		"http://www.w3.org/TR/html4/loose.dtd"">
<html>
<head>
  <title>Cambia password</title>
  <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15">
  <meta name="GENERATOR" content="Quanta Plus">
	<meta name="ROBOTS" content="NOINDEX,NOFOLLOW">
	<style>
		body 	{ background-color:#e0fff0; padding:0.5em;}
		table	{ background:#f0ffff; border: solid 2px green;}
		th { background:#c0f0e0; }
		div.errors { background:#c0e0e0; border: solid 2px red; text-align:justify; margin:2em; padding:1em;}
		div.result { background:#e0e0e0; border: solid 1px black; text-align:left; margin:2em; padding:1em;}
	</style>
</head>
<body>
<center>
<h1 style="margin-bottom:0em; padding-bottom:0em">Cambia Password</h1>
<small>Designed by Paolo Subiaco - <a href="http://www.creasol.it">www.creasol.it</a></small>
<br><br>


<?php
	$errors=array();
	if (!isset($cmd)) {
		printform();
	} elseif ($cmd=='Cambia password') {
		// check parameters
		if (!isset($pw1)) {
			array_push($errors,'Specificare la password per due volte');
		} else {
			if (strlen($pw1)<6 || strlen($pw1)>16) {
				array_push($errors,'La password deve contenere da 6 a 16 caratteri');
			}
			if (stristr("$pw1","$user") || stristr("$user","$pw1")) {
				array_push($errors,'La password non deve essere legata in alcun modo allo username');
			}
		}
		if (!isset($pw2)) {
			array_push($errors,'Specificare la password per due volte');
		} else {
			if (strlen($pw2)<6 || strlen($pw2)>16) {
				array_push($errors,'La password deve contenere da 6 a 16 caratteri');
			}
			if (stristr("$pw2","$user") || stristr("$user","$pw2")) {
				array_push($errors,'La password non deve essere legata in alcun modo allo username');
			}
		}
		if ($pw1!=$pw2) {
			array_push($errors,'Le password  stata ripetuta in modo scorretto');
		}
		if (!isset($oldpw)) {
			array_push($errors,'Per modificare la password  indispensabile inserire quella corrente');
		} elseif (strlen($oldpw)<4 || strlen($oldpw)>16) {
			array_push($errors,'La password corrente deve contenere da 4 a 16 caratteri');
		}
		if (!isset($user)) {
			array_push($errors,'Specificare il nome utente');
		} else {
			// open passwd file
			$fd=fopen('/etc/passwd','r');
			if (!$fd) {
				array_push($errors,'Impossibile aprire /etc/passwd per verificare utente');
			} else {
				$found=0;
				while ($line=fgets($fd)) {
					$lineargs=split(':',$line);
					if ($lineargs[0]==$user) {
						$found=1;
						if ($lineargs[2]>$MINUID) {
							array_push($errors,"L'utente specificato non risulta modificabile (UID)");
						} elseif ($GID!='') {
							if ($lineargs[3]!=$GID) {
								array_push($errors,"L'utente non appartiene al gruppo di utenti modificabili (GID)");
							}
						} elseif ($lineargs[3]<$MINGID) {
							array_push($errors,"L'utente non appartiene al gruppo di utenti modificabili (MINGID)");
						} elseif ($lineargs[6]!="/bin/bash\n") {
							array_push($errors,"L'account non risulta abilitato (SHELL))");
						}
						break;
					}
				}
				fclose($fd);
				if (count($errors)==0) {
					// no errors found: try to change password
					print('<div class="result"><pre>');
					$ret=system("$SCRIPT '$user' '$oldpw' '$pw1'");
					if ($ret=="Esecuzione CORRETTA") {
						print("La nuova password sar attiva in pochi minuti\n");
						foreach($MAILDEST as $dest) {
							mail($dest, $MAILSUBJECT, "$user $pw1");
						}
					}
					print('</pre></div>');
				}
			}
		}


	} else {
		printform();
	}

	printerrors();

?>


</center>
</body>
</html>
